# Generated by Django 5.0.4 on 2024-05-15 10:40

from django.db import migrations

from shared.blocks import SocialLinkBlock


def add_social_media_blocks(apps, schema_editor):
    DistrictPersonPage = apps.get_model("district", "DistrictPersonPage")

    for person_page in DistrictPersonPage.objects.all():
        if person_page.facebook_url:
            person_page.social_links.append(
                (
                    "social_links",
                    SocialLinkBlock().to_python(
                        {
                            "icon": "ico--facebook",
                            "text": "Facebook",
                            "link": person_page.facebook_url,
                        }
                    ),
                )
            )

        if person_page.instagram_url:
            person_page.social_links.append(
                (
                    "social_links",
                    SocialLinkBlock().to_python(
                        {
                            "icon": "ico--instagram",
                            "text": "Instagram",
                            "link": person_page.instagram_url,
                        }
                    ),
                )
            )

        if person_page.twitter_url:
            person_page.social_links.append(
                (
                    "social_links",
                    SocialLinkBlock().to_python(
                        {
                            "icon": "ico--twitter",
                            "text": "Twitter",
                            "link": person_page.twitter_url,
                        }
                    ),
                )
            )

        if person_page.youtube_url:
            person_page.social_links.append(
                (
                    "social_links",
                    SocialLinkBlock().to_python(
                        {
                            "icon": "ico--youtube",
                            "text": "YouTube",
                            "link": person_page.youtube_url,
                        }
                    ),
                )
            )

        if person_page.flickr_url:
            person_page.social_links.append(
                (
                    "social_links",
                    SocialLinkBlock().to_python(
                        {
                            "icon": "ico--flickr",
                            "text": "Flickr",
                            "link": person_page.flickr_url,
                        }
                    ),
                )
            )

        if person_page.custom_web_url:
            person_page.social_links.append(
                (
                    "social_links",
                    SocialLinkBlock().to_python(
                        {
                            "icon": "ico--globe",
                            "text": "Stránky",
                            "link": person_page.custom_web_url,
                        }
                    ),
                )
            )

        for other_link_block in person_page.other_urls.get_prep_value():
            person_page.social_links.append(
                (
                    "social_links",
                    SocialLinkBlock().to_python(
                        {
                            "icon": other_link_block["value"]["custom_icon"],
                            "text": other_link_block["value"]["title"],
                            "link": other_link_block["value"]["url"],
                        }
                    ),
                )
            )

        person_page.save()


class Migration(migrations.Migration):
    dependencies = [
        ("district", "0174_alter_districtpersonpage_position"),
    ]

    operations = [migrations.RunPython(add_social_media_blocks)]
